#ifndef __DLGPALET_H
#define __DLGPALET_H

#ifndef __DIALOG_H
#include <dialog.h>
#endif

#ifndef __DIR_H
#include <dir.h>
#endif

#ifndef __DUMPWIN_H
#include "dumpwin.h"
#endif

#ifndef __PALFILE_H
#include "palfile.h"
#endif


// Palette dialog class
_CLASSDEF(TPaletteDialog)
class TPaletteDialog : public TDialog
{
public:
	BOOL		Initialized;		// Flag is true if all is well

	PTPaletteFile	PaletteList;		// List of palette files
        PTPaletteFile	PaletteLast;
	PTPaletteFile	CurrentPalette;		// Current selected palette from listbox

	TPaletteFile	**ParentPalette;	// Parent palette file structure

	LOGPALETTE	*LogPalette;		// Used Logical palette
	HPALETTE	hPalette;		// Palette handle
	 
	BITMAPINFO	*BBitmapInfo;		// Button bitmap info
	long		BBits[MAXCOLORS];	// Button BitmapBits;

public:
	TPaletteDialog(PTWindowsObject aParent, LPSTR aTitle, TPaletteFile **PalFile, PTModule aModule = NULL);
	~TPaletteDialog();

	virtual void SetupWindow();
	virtual void DrawItem(DRAWITEMSTRUCT _FAR & di);

	virtual void WMQueryNewPalette(RTMessage aMsg)	= [WM_FIRST + WM_QUERYNEWPALETTE];

	virtual void Ok(RTMessage aMsg)			= [ID_FIRST + IDOK];
	virtual void Cancel(RTMessage aMsg)		= [ID_FIRST + IDCANCEL];

	virtual void IDPalListbox(RTMessage aMsg)	= [ID_FIRST + ID_PALLISTBOX];

	PTPaletteFile LoadPaletteFile(char *path);
	PTPaletteFile FindPaletteName(char *name);

	void Error(char *fmt, ...);
	int Question(char *fmt, ...);
};

#endif
