//
//************************************************************************
// File                 : dumpwin.cpp  
// Module               : 	
// Project              : View Dumpfile  
// Description          : dumpwin.cpp support action messages
// Creation date        : 
// Last update          : 
// Author(s)            : Bertho Stultiens (BS)
// Version              :
// Compiler             : Borland C++ 3.1
//	switches	:
// Remarks              :
// Modification History :
//************************************************************************
// 

#include <owl.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <bwcc.h>
#include "dlgparm.h"
#include "viewdmp.h"
#include "dumpwin.h"
#include "dlgpalet.h"
#include "ini.h"


//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::WMLButtonDown(RTMessage aMsg)
{
	int xpos = LOWORD(aMsg.LParam);
	int ypos = HIWORD(aMsg.LParam);
	HDC DC = GetDC(HWindow);

	switch(ActionState)
	{
	case eAct_Nop:
        	break;
        	
	case eAct_ZoomWait:
		if(XYInRect(xpos, ypos, PicRect))
		{
			// If clicked in picture box mark start position
			ZoomWXStart = xpos;
			ZoomWYStart = ypos;
			ZoomWXBox = 0;
			ZoomWYBox = 0;
			ActionState = eAct_ZoomSize;
                        InvertZoomBox(DC);
		}
		else
		{
                	// If clicked out of Picture box return to nop-state
			ActionState = eAct_Nop;
                        SetCursor(Cursor = LoadCursor(NULL, IDC_ARROW));
                }
		break;
        	
	case eAct_SetCenter:
        	break;
        	
	case eAct_Cross:
        	break;
        	
	case eAct_CrossDrag:
        	break;

	case eAct_ZoomSize:	// If this happens then we missed the eAct_ZoomWait state
	case eAct_ZoomDrag:	// If this happens then we missed the eAct_ZoomSize state
        	Error("Illegal state (%d) in LButtonDown", ActionState);
	default:
		ActionState = eAct_Nop;
		SetCursor(Cursor = LoadCursor(NULL, IDC_ARROW));
		break;
	}

	ReleaseDC(HWindow, DC);
}


//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::WMLButtonUp(RTMessage aMsg)
{
	int xpos = LOWORD(aMsg.LParam);
	int ypos = HIWORD(aMsg.LParam);
	HDC DC = GetDC(HWindow);

	switch(ActionState)
	{
	case eAct_Nop:
        	break;
        	
	case eAct_ZoomSize:		// We reached the end of zoom	       
		long mi = 0x7ffffffel;	// Use local vars to lose extra derefs to class instance
		long ma = 0x80000000l;
		int zt;
		int zb;
		int zl;
		int zr;
		int x;
                int y;
		int yy;	// Zoomed bitmap bits index

		ActionState = eAct_Nop;		// Return to nop state
		IsZoomedFlag = TRUE;		// Mark we're zoomed
                InvertZoomBox(DC);      	// Remove zoom box
		ZoomWXBox = xpos - ZoomWXStart; // Get last reported mouse position
		ZoomWYBox = ypos - ZoomWYStart;
		Cursor = LoadCursor(NULL, IDC_ARROW);	// Reset cursor
		SetCursor(LoadCursor(GetApplication()->hInstance, "CURSOR_CALC"));

		// Calculate the zoomed area clipped against the picture box
                // Watch out to use W#2IV#() assigning to Zoom#, They are used by the macro! 
		zb = WY2IVY(Bound(ZoomWYStart+ZoomWYBox+1, PRY1, PRY2));
		zt = WY2IVY(Bound(ZoomWYStart-ZoomWYBox,   PRY1, PRY2));
		zr = WX2IVX(Bound(ZoomWXStart+ZoomWXBox+1, PRX1, PRX2));
		zl = WX2IVX(Bound(ZoomWXStart-ZoomWXBox,   PRX1, PRX2));

                // Be sure to be within array limits and LRTB is LRTB and not RLBT 
                ZoomT = Bound(zt, 0, YSIZE-1);
		ZoomL = Bound(zl, 0, XSIZE-1);
		ZoomB = Bound(zb, 0, YSIZE-1);
		ZoomR = Bound(zr, 0, XSIZE-1);

		if(ZoomL > ZoomR) Swap(ZoomL, ZoomR);
		if(ZoomT > ZoomB) Swap(ZoomT, ZoomB);

		zb = ZoomB;	// For less derefs in loops below
		zr = ZoomR;

		// Determine minimum, maximum zoomed area (can be faster in ASM)
		for(y = ZoomT; y <= zb; y++)
		{
	                long *lcacheptr = &LArray[y][ZoomL];
			for(x = ZoomL; x <= zr; x++)
			{
				if(*lcacheptr != 0x7fffffffl)
	                        {
					if(*lcacheptr < mi) mi = *lcacheptr;
					if(*lcacheptr > ma) ma = *lcacheptr;
				}
				lcacheptr++; 
			}
		}

		ZoomMin = mi;
		ZoomMax = ma;

		long zmin = ZoomMin;
		long zdif = ZoomMax - ZoomMin;

		// Create zoomed bitmap bits
                // Note that the origin of the zoomed bitmap is 0,0
		for(yy = 0, y = ZoomT; y <= zb; yy++, y++)
		{
			long *lcacheptr = &LArray[y][ZoomL];
	                char *ccacheptr = ZoomBits[yy];
			for(x = ZoomL; x <= zr; x++)
			{
				if(*lcacheptr != 0x7fffffffl)
				{
					*(unsigned char *)ccacheptr = (unsigned char)((*lcacheptr - zmin) * (long)(MAXCOLORS-1) / zdif + 10);
				}
				else
				{
                	        	*ccacheptr = 0;
				}
				lcacheptr++;
				ccacheptr++; 
			}
		}

		// Recalculate imagecentre in window coordinates
		Wcx = IVX2WX(lCenterX);	       
		Wcy = IVY2WY(lCenterY);

		// Repaint
		InvalidateRect(HWindow, &ClientRect, TRUE);
		DestroyCursor(SetCursor(Cursor));

		break;
        	
	case eAct_ZoomDrag:
        	break;
        	
	case eAct_SetCenter:
		break;
        	
	case eAct_Cross:
        	break;
        	
	case eAct_CrossDrag:
        	break;

	case eAct_ZoomWait:	// If this happens then we missed a button down...
	default:
		ActionState = eAct_Nop;
		SetCursor(Cursor = LoadCursor(NULL, IDC_ARROW));
		break;
	}

	ReleaseDC(HWindow, DC);
}


//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::WMRButtonDown(RTMessage)
{
//	int xpos = LOWORD(aMsg.LParam);
//	int ypos = HIWORD(aMsg.LParam);
	HDC DC = GetDC(HWindow);

	switch(ActionState)
	{
	case eAct_ZoomSize:
		SetCursor(Cursor = LoadCursor(NULL, IDC_CROSS));
                POINT pt;
                GetCursorPos(&pt);
                SetCursorPos(pt.x-ZoomWXBox, pt.y-ZoomWYBox);
		ActionState = eAct_ZoomDrag;
		break;


	case eAct_SetCenter:
        	break;
        	
	case eAct_Cross:
        	break;
        	
	case eAct_CrossDrag:
        	break;

	case eAct_ZoomDrag:
		Error("Illegal state (%d) in WMRButtonDown", ActionState);

	case eAct_ZoomWait:
	case eAct_Nop:
	default:
		ActionState = eAct_Nop;
		SetCursor(Cursor = LoadCursor(NULL, IDC_ARROW));
		break;
	}

	ReleaseDC(HWindow, DC);
}


//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::WMRButtonUp(RTMessage aMsg)
{
	int xpos = LOWORD(aMsg.LParam);
	int ypos = HIWORD(aMsg.LParam);
	HDC DC = GetDC(HWindow);

	switch(ActionState)
	{
	case eAct_ZoomDrag:
		if(XYInRect(xpos, ypos, PicRect))
		{
			// If moved within the picture box, mark box

			InvertZoomBox(DC);	// Clear old rectangle
			ZoomWXStart = xpos;
			ZoomWYStart = ypos;
			InvertZoomBox(DC);	// Set new rectangle
		}
		ActionState = eAct_ZoomSize;
		SetCursor(Cursor = CursorZoom);
		POINT pt;
		GetCursorPos(&pt);
                SetCursorPos(pt.x+ZoomWXBox, pt.y+ZoomWYBox);
		break;
        	
	case eAct_SetCenter:
        	break;
        	
	case eAct_Cross:
        	break;
        	
	case eAct_CrossDrag:
        	break;

	case eAct_ZoomSize:
        	Error("Illegal state (%d) in WMRButtonUp", ActionState);
	default:
		ActionState = eAct_Nop;
		SetCursor(Cursor = LoadCursor(NULL, IDC_ARROW));
	case eAct_ZoomWait:
	case eAct_Nop:
		break;
	}

	ReleaseDC(HWindow, DC);
}


//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
#define CSINDEXLINE	5

void TDumpWindow::WMMouseMove(RTMessage aMsg)
{
	SetCursor(Cursor);
	int xpos = LOWORD(aMsg.LParam);
	int ypos = HIWORD(aMsg.LParam);
	RECT cr;

	GetClientRect(HWindow, &cr);
        HDC DC = GetDC(HWindow);
	HFONT hOldFont = (HFONT)SelectObject(DC, hFont);

        // Handle general cases for drawing array info in status bar
	switch(ActionState)
	{
	case eAct_Nop:
	case eAct_ZoomWait:
	case eAct_ZoomSize:
	case eAct_ZoomDrag:
	case eAct_SetCenter:
	case eAct_CrossDrag:
		if(XYInRect(xpos, ypos, PicRect))
		{
			// Print the array in the status bar
			int px     = WX2IVX(xpos);
			int py     = WY2IVY(ypos);   
			double dx  = (double)(px - lCenterX) / dXSIZE * lWidth;
			double dy  = (double)(py - lCenterY) / dYSIZE * lHeight;
			double r   = sqrt(dx*dx + dy*dy);
			double ang = dx == 0.0 ? (dy == 0.0 ? 0.0 : (dy < 0.0 ? 90.0 : 270.0)) : (atan2(dy, -dx) / M_PI * 180.0 + 180.0);

			if(px < 0 || px >= XSIZE || py < 0 || py >= YSIZE)
			{
                        	break;
			} 
			char str[128];
			int cnt = sprintf(str, "x, y: %2.3lf, %2.3lf (index: %+3d, %+3d; center: %+3d, %+3d); r, p: %2.3lf, %3.1lf = z: %2.4lf               ",
					  dx, dy,
					  px, py,
					  px - lCenterX, py - lCenterY,
					  r, ang,
					  Array[py][px]);
			TextOut(DC, 10, cr.bottom - STATUSBAR + 2, str, cnt);

                        int color;
			if(ArrayIsZoomed())
			{
				color = *(unsigned char *)&ZoomBits[py-ZoomT][px-ZoomL];
			}
			else
			{
				color = *(unsigned char *)&OrgBits[py][px];
			}

                        // Always remove color index line
			HPEN hp = (HPEN)GetStockObject(WHITE_PEN);
			HGDIOBJ op = SelectObject(DC, hp);
			if(csidx != -1)
			{
				MoveTo(DC, PALX1-2, csidx);
				LineTo(DC, PALX1-2-CSINDEXLINE, csidx);
			}
			SelectObject(DC, op);

			// Add color index line if in range
			if(color >= 10 && color < MAXCOLORS+10)
			{
				csidx = PALY2-1 - (int)((double)PALH * (double)(color-10) / (double)MAXCOLORS + 0.5);
				MoveTo(DC, PALX1-2, csidx);
				LineTo(DC, PALX1-2-CSINDEXLINE, csidx);
			}
		}
        	break;
        	
	case eAct_Cross:
        	break;

	default:
		ActionState = eAct_Nop;
		SetCursor(Cursor = LoadCursor(NULL, IDC_ARROW));
		break;
	}

        // Handle special state action
	switch(ActionState)
	{
	case eAct_Nop:
        	break;
        	
	case eAct_ZoomWait:
        	break;
        	
	case eAct_ZoomSize:
		if(XYInRect(xpos, ypos, PicRect))
		{
			// If moved within the picture box, mark box

			InvertZoomBox(DC);	// Clear old rectangle
			ZoomWXBox = xpos - ZoomWXStart;
			ZoomWYBox = ypos - ZoomWYStart;
			InvertZoomBox(DC);	// Set new rectangle
		}
		break;
        	
	case eAct_ZoomDrag:
		if(XYInRect(xpos, ypos, PicRect))
		{
			// If moved within the picture box, mark box

			InvertZoomBox(DC);	// Clear old rectangle
			ZoomWXStart = xpos;
			ZoomWYStart = ypos;
			InvertZoomBox(DC);	// Set new rectangle
		}
		break;
        	
	case eAct_SetCenter:
        	break;
        	
	case eAct_Cross:
        	break;
        	
	case eAct_CrossDrag:
        	break;
	}

        SelectObject(DC, hOldFont);
        ReleaseDC(HWindow, DC);
}


//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	:
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::WMSize(RTMessage aMsg)
{
	TWindow::WMSize(aMsg);
	CalcBorders();
}


//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	:
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::WMSetFocus(RTMessage Msg)
{
	HDC DC = GetDC(HWindow);
	if(ActionState == eAct_ZoomSize || ActionState == eAct_ZoomDrag)
	{
		InvertZoomBox(DC);
	}

	SendMessage(HWindow, WM_QUERYNEWPALETTE, 0, 0L);

	ReleaseDC(HWindow, DC);
	DefWndProc(Msg);	// Revert to normal processing
}


//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	:
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::WMKillFocus(RTMessage Msg)
{
	if(ActionState == eAct_ZoomSize || ActionState == eAct_ZoomDrag)
        {
		HDC DC = GetDC(HWindow);
                InvertZoomBox(DC);
		ReleaseDC(HWindow, DC);
	}

	DefWndProc(Msg);	// Revert to normal processing
}


//
//*****************************************************************************
// Function	: TDumpWindow::CMViewParameter
// Syntax	: void CMViewParameter(RTMessage aMsg)
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::CMViewParameter(RTMessage)
{
	GetApplication()->ExecDialog(new TDialogParameter(this, "DIALOG_PARAMETER"));
}
   

//
//*****************************************************************************
// Function	: TDumpWindow::CMViewZoomIn
// Syntax	: void CMViewZoomIn(RTMessage)
// Input	:
// Output	:
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::CMViewZoomIn(RTMessage)
{
	if(ActionState == eAct_Nop)
	{
		SetCursor(Cursor = CursorZoom);
                ActionState = eAct_ZoomWait;
	}
}


//
//*****************************************************************************
// Function	: TDumpWindow::CMViewZoomOut
// Syntax	: void CMViewZoomOut(RTMessage)
// Input	:
// Output	:
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::CMViewZoomOut(RTMessage)
{
	if(ArrayIsZoomed() && ActionState == eAct_Nop)
        {
		IsZoomedFlag = FALSE;
		ZoomL = 0;
		ZoomT = 0;
		ZoomR = XSIZE-1;
		ZoomB = YSIZE-1;
		ZoomMin = lMin;
                ZoomMax = lMax;
		// Recalculate imagecentre in window coordinates
		Wcx = IVX2WX(lCenterX);	       
		Wcy = IVY2WY(lCenterY);

		InvalidateRect(HWindow, &ClientRect, TRUE);
        }
}


//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	:
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::CMViewPalette(RTMessage)
{
	PTPaletteFile palfile = PaletteFile;
	int result = GetApplication()->ExecDialog(new TPaletteDialog(this, "DIALOG_PALETTE", &palfile));

	if(result == IDOK && palfile != NULL)
	{
		PaletteFile = palfile;
		memcpy(&LogPalette->palPalEntry[10], &(palfile->Palette), sizeof(PALETTEENTRY)*MAXCOLORS);
		UnrealizeObject(hPalette);
		HDC DC = GetDC(HWindow);
		HPALETTE opal = SelectPalette(DC, hPalette, FALSE);
                RealizePalette(DC);
		AnimatePalette(hPalette, 10, MAXCOLORS, palfile->Palette);
		InvalidateRect(HWindow, &ClientRect, FALSE);
		SelectPalette(DC, opal, FALSE);
		ReleaseDC(HWindow, DC);
		SetIniParameter(eip_LastPaletteLoaded, palfile->Path);
        }
}

//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	:
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::CMFilePrint(RTMessage)	{ MessageBox(HWindow, "Print", "File", MB_OK); }
void TDumpWindow::CMFilePrintSetup(RTMessage)	{ MessageBox(HWindow, "Print Setup", "File", MB_OK); }

void TDumpWindow::CMViewCross(RTMessage)	{ MessageBox(HWindow, "Cross", "View", MB_OK); }
void TDumpWindow::CMViewMajorCross(RTMessage)	{ MessageBox(HWindow, "Four Cross", "View", MB_OK); }
void TDumpWindow::CMViewSetCenter(RTMessage)	{ MessageBox(HWindow, "Set Center", "View", MB_OK); }
void TDumpWindow::CMViewPreferences(RTMessage)	{ MessageBox(HWindow, "Preferences", "View", MB_OK); }
void TDumpWindow::CMViewScaleTicks(RTMessage)	{ MessageBox(HWindow, "Scale Ticks", "View", MB_OK); }

//
//*****************************************************************************
// Function	: TDumpWindow::BM...
// Syntax	: void BM...(RTMessage Msg)
// Input	:
// Output	:
// Description	: All messages are pased to the Menu counterpart 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::BMPrint(RTMessage)	   { SendMessage(HWindow, WM_COMMAND, CM_FILEPRINT,       0l); }
void TDumpWindow::BMPrintSetup(RTMessage)  { SendMessage(HWindow, WM_COMMAND, CM_FILEPRINTSETUP,  0l); }
void TDumpWindow::BMZoomIn(RTMessage)      { SendMessage(HWindow, WM_COMMAND, CM_VIEWZOOMIN,      0l); }
void TDumpWindow::BMZoomOut(RTMessage)     { SendMessage(HWindow, WM_COMMAND, CM_VIEWZOOMOUT,     0l); }
void TDumpWindow::BMCross(RTMessage)       { SendMessage(HWindow, WM_COMMAND, CM_VIEWCROSS,       0l); }
void TDumpWindow::BMMajorCross(RTMessage)  { SendMessage(HWindow, WM_COMMAND, CM_VIEWMAJORCROSS,  0l); }
void TDumpWindow::BMPalette(RTMessage)     { SendMessage(HWindow, WM_COMMAND, CM_VIEWPALETTE,     0l); }
void TDumpWindow::BMSetCenter(RTMessage)   { SendMessage(HWindow, WM_COMMAND, CM_VIEWSETCENTER,   0l); }
void TDumpWindow::BMParameter(RTMessage)   { SendMessage(HWindow, WM_COMMAND, CM_VIEWPARAMETER,   0l); }
void TDumpWindow::BMPreferences(RTMessage) { SendMessage(HWindow, WM_COMMAND, CM_VIEWPREFERENCES, 0l); }
void TDumpWindow::BMScaleTicks(RTMessage)  { SendMessage(HWindow, WM_COMMAND, CM_VIEWSCALETICKS,  0l); }

//
//*****************************************************************************
// Function	: 
// Syntax	: 
// Input	:
// Output	:
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TDumpWindow::InvertZoomBox(HDC DC)
{
	// Clip zoombox to picture box
	int sx = Bound(ZoomWXStart-ZoomWXBox,   PRX1, PRX2); 
	int ex = Bound(ZoomWXStart+ZoomWXBox+1, PRX1, PRX2);
	int sy = Bound(ZoomWYStart-ZoomWYBox,   PRY1, PRY2);
	int ey = Bound(ZoomWYStart+ZoomWYBox+1, PRY1, PRY2);

	int rop = SetROP2(DC, R2_XORPEN);
	HBRUSH hb = (HBRUSH)SelectObject(DC, GetStockObject(BLACK_BRUSH));
	HPEN hp = (HPEN)SelectObject(DC, GetStockObject(WHITE_PEN));
	Rectangle(DC, sx, sy, ex, ey);
        SelectObject(DC, hp);
	SelectObject(DC, hb);
	SetROP2(DC, rop);
}

