/*
 ******************************************************************************
 * File                 : ekmedit.cpp
 * Module               : EKM
 * Project              : EKM
 * Description          : customizes edit controls
 * Creation date        : 01-Apr-1993
 * Last update          : 01-Apr-1993
 * Author(s)            : Bertho Stultiens (BS)
 * Version              : 1.0
 * Compiler             : Borland C++ 3.1
 *      switches        :
 * Remarks              :
 * Modification History :
 * BS   01-Apr-1993:    Created this file
 ******************************************************************************
 */

#include <owl.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <dir.h>
#include <dos.h>
#include <alloc.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <listbox.h>
#pragma hdrstop

#include "ekmedit.h"


//
//*****************************************************************************
// Method 	: TCharEdit::NFENKillFocus
// Syntax       : void NFENKillFocus(RTMessage)
// Access scope	: virtual public
// Input        :
//	aMsg	- not used message
// Output       : nop
// Description  : Validate the typed constant when losing the input focus
// Remarks      :
//*****************************************************************************
//
void TCharEdit::NFENKillFocus(RTMessage aMsg)
{
	char str[32];
        char *endptr;
        char val;

	GetText(str, 32);
	val = (char)strtol(str, &endptr, 0);
	if(*endptr != '\0')
	{
        	MessageBeep(-1);
        }
	sprintf(str, "%d", val);
	SetText(str);
	DefNotificationProc(aMsg);
}


//
//*****************************************************************************
// Method 	: TUCharEdit::NFENKillFocus
// Syntax       : void NFENKillFocus(RTMessage)
// Access scope	: virtual public
// Input        :
//	aMsg	- not used message
// Output       : nop
// Description  : Validate the typed constant when losing the input focus
// Remarks      :
//*****************************************************************************
//
void TUCharEdit::NFENKillFocus(RTMessage aMsg)
{
	char str[32];
        char *endptr;
        unsigned char val;

	GetText(str, 32);
	val = (unsigned char)strtoul(str, &endptr, 0);
	if(*endptr != '\0')
	{
        	MessageBeep(-1);
        }
	sprintf(str, "0x%02X", val);
        SetText(str);
	DefNotificationProc(aMsg);
}


//
//*****************************************************************************
// Method 	: TIntEdit::NFENKillFocus
// Syntax       : void NFENKillFocus(RTMessage)
// Access scope	: virtual public
// Input        :
//	aMsg	- not used message
// Output       : nop
// Description  : Validate the typed constant when losing the input focus
// Remarks      :
//*****************************************************************************
//
void TIntEdit::NFENKillFocus(RTMessage aMsg)
{
	char str[32];
        char *endptr;
        int val;

	GetText(str, 32);
	val = (int)strtol(str, &endptr, 0);
	if(*endptr != '\0')
	{
        	MessageBeep(-1);
        }
	sprintf(str, "%d", val);
        SetText(str);
	DefNotificationProc(aMsg);
}


//
//*****************************************************************************
// Method 	: TUIntEdit::NFENKillFocus
// Syntax       : void NFENKillFocus(RTMessage)
// Access scope	: virtual public
// Input        :
//	aMsg	- not used message
// Output       : nop
// Description  : Validate the typed constant when losing the input focus
// Remarks      :
//*****************************************************************************
//
void TUIntEdit::NFENKillFocus(RTMessage aMsg)
{
	char str[32];
        char *endptr;
        unsigned int val;

	GetText(str, 32);
	val = (unsigned int)strtoul(str, &endptr, 0);
	if(*endptr != '\0')
	{
        	MessageBeep(-1);
        }
	sprintf(str, "0x%04X", val);
        SetText(str);
	DefNotificationProc(aMsg);
}


//
//*****************************************************************************
// Method 	: TLongEdit::NFENKillFocus
// Syntax       : void NFENKillFocus(RTMessage)
// Access scope	: virtual public
// Input        :
//	aMsg	- not used message
// Output       : nop
// Description  : Validate the typed constant when losing the input focus
// Remarks      :
//*****************************************************************************
//
void TLongEdit::NFENKillFocus(RTMessage aMsg)
{
	char str[32];
        char *endptr;
        long val;

	GetText(str, 32);
	val = strtol(str, &endptr, 0);
	if(*endptr != '\0')
	{
        	MessageBeep(-1);
        }
	sprintf(str, "%ld", val);
        SetText(str);
	DefNotificationProc(aMsg);
}


//
//*****************************************************************************
// Method 	: TULongEdit::NFENKillFocus
// Syntax       : void NFENKillFocus(RTMessage)
// Access scope	: virtual public
// Input        :
//	aMsg	- not used message
// Output       : nop
// Description  : Validate the typed constant when losing the input focus
// Remarks      :
//*****************************************************************************
//
void TULongEdit::NFENKillFocus(RTMessage aMsg)
{
	char str[32];
        char *endptr;
        unsigned long val;

	GetText(str, 32);
	val = strtoul(str, &endptr, 0);
	if(*endptr != '\0')
	{
        	MessageBeep(-1);
        }
	sprintf(str, "0x%08lX", val);
        SetText(str);
	DefNotificationProc(aMsg);
}


//
//*****************************************************************************
// Method 	: TStringEdit::NFENKillFocus
// Syntax       : void NFENKillFocus(RTMessage)
// Access scope	: virtual public
// Input        :
//	aMsg	- not used message
// Output       : nop
// Description  : Validate the typed constant when losing the input focus
// Remarks      :
//*****************************************************************************
//
void TStringEdit::NFENKillFocus(RTMessage aMsg)
{
	DefNotificationProc(aMsg);
}


//
//*****************************************************************************
// Method 	: TDoubleEdit::NFENKillFocus
// Syntax       : void NFENKillFocus(RTMessage)
// Access scope	: virtual public
// Input        :
//	aMsg	- not used message
// Output       : nop
// Description  : Validate the typed constant when losing the input focus
// Remarks      :
//*****************************************************************************
//
void TDoubleEdit::NFENKillFocus(RTMessage aMsg)
{
	char str[32];
        char *endptr;
        double val;

	GetText(str, 32);
	val = strtod(str, &endptr);
	if(*endptr != '\0')
	{
        	MessageBeep(-1);
        }
	sprintf(str, "%.14lg", val);
	SetText(str);
        DefNotificationProc(aMsg);
}


//
//*****************************************************************************
// Function    	: TCharEdit::GetValue
// Syntax       : BOOL GetValue(char& val, BOOL& changed)
// Access scope : public
// Input        :
//	val	- Reference to destination
//	changed	- Reference to variable to flag any change	
// Output       : Sets 'val' and 'changed', returns TRUE if is ok, FALSE otherwise.
// Description  : The edit field is scanned for a char and is assigned to
//		  val if it has changed. If it has changed, 'changed' is set to TRUE
// Remarks      :
//*****************************************************************************
//
BOOL TCharEdit::GetValue(char& val, BOOL& changed)
{
	char str[32];
        char *endptr;
        char newval;

	GetText(str, 32);
	newval = (char)strtol(str, &endptr, 0);
	if(newval != val)
	{
		val = newval;
                changed = TRUE;
        }
	return *endptr == '\0';
}


//
//*****************************************************************************
// Function    	: TUCharEdit::GetValue
// Syntax       : BOOL GetValue(unsigned char& val, BOOL& changed)
// Access scope : public
// Input        :
//	val	- Reference to destination
//	changed	- Reference to variable to flag any change	
// Output       : Sets 'val' and 'changed', returns TRUE if is ok, FALSE otherwise.
// Description  : The edit field is scanned for a unsigned char and is assigned to
//		  val if it has changed. If it has changed, 'changed' is set to TRUE
// Remarks      :
//*****************************************************************************
//
BOOL TUCharEdit::GetValue(unsigned char& val, BOOL& changed)
{
	char str[32];
        char *endptr;
        unsigned char newval;

	GetText(str, 32);
	newval = (unsigned char)strtoul(str, &endptr, 0);
	if(newval != val)
	{
		val = newval;
                changed = TRUE;
        }
	return *endptr == '\0';
}


//
//*****************************************************************************
// Function    	: TIntEdit::GetValue
// Syntax       : BOOL GetValue(int& val, BOOL& changed)
// Access scope : public
// Input        :
//	val	- Reference to destination
//	changed	- Reference to variable to flag any change	
// Output       : Sets 'val' and 'changed', returns TRUE if is ok, FALSE otherwise.
// Description  : The edit field is scanned for a int and is assigned to
//		  val if it has changed. If it has changed, 'changed' is set to TRUE
// Remarks      :
//*****************************************************************************
//
BOOL TIntEdit::GetValue(int& val, BOOL& changed)
{
	char str[32];
        char *endptr;
        int newval;

	GetText(str, 32);
	newval = (int)strtol(str, &endptr, 0);
	if(newval != val)
	{
		val = newval;
                changed = TRUE;
        }
	return *endptr == '\0';
}


//
//*****************************************************************************
// Function    	: TUIntEdit::GetValue
// Syntax       : BOOL GetValue(unsigned int& val, BOOL& changed)
// Access scope : public
// Input        :
//	val	- Reference to destination
//	changed	- Reference to variable to flag any change	
// Output       : Sets 'val' and 'changed', returns TRUE if is ok, FALSE otherwise.
// Description  : The edit field is scanned for a unsigned char and is assigned to
//		  val if it has changed. If it has changed, 'changed' is set to TRUE
// Remarks      :
//*****************************************************************************
//
BOOL TUIntEdit::GetValue(unsigned int& val, BOOL& changed)
{
	char str[32];
        char *endptr;
        unsigned int newval;

	GetText(str, 32);
	newval = (unsigned int)strtoul(str, &endptr, 0);
	if(newval != val)
	{
		val = newval;
                changed = TRUE;
        }
	return *endptr == '\0';
}


//
//*****************************************************************************
// Function    	: TLongEdit::GetValue
// Syntax       : BOOL GetValue(long& val, BOOL& changed)
// Access scope : public
// Input        :
//	val	- Reference to destination
//	changed	- Reference to variable to flag any change	
// Output       : Sets 'val' and 'changed', returns TRUE if is ok, FALSE otherwise.
// Description  : The edit field is scanned for a long and is assigned to
//		  val if it has changed. If it has changed, 'changed' is set to TRUE
// Remarks      :
//*****************************************************************************
//
BOOL TLongEdit::GetValue(long& val, BOOL& changed)
{
	char str[32];
        char *endptr;
        long newval;

	GetText(str, 32);
	newval = strtol(str, &endptr, 0);
	if(newval != val)
	{
		val = newval;
                changed = TRUE;
        }
	return *endptr == '\0';
}


//
//*****************************************************************************
// Function    	: TULongEdit::GetValue
// Syntax       : BOOL GetValue(unsigned long& val, BOOL& changed)
// Access scope : public
// Input        :
//	val	- Reference to destination
//	changed	- Reference to variable to flag any change	
// Output       : Sets 'val' and 'changed', returns TRUE if is ok, FALSE otherwise.
// Description  : The edit field is scanned for an unsigned long and is assigned to
//		  val if it has changed. If it has changed, 'changed' is set to TRUE
// Remarks      :
//*****************************************************************************
//
BOOL TULongEdit::GetValue(unsigned long& val, BOOL& changed)
{
	char str[32];
        char *endptr;
        unsigned long newval;

	GetText(str, 32);
	newval = strtoul(str, &endptr, 0);
	if(newval != val)
	{
		val = newval;
                changed = TRUE;
        }
	return *endptr == '\0';
}


//
//*****************************************************************************
// Function    	: TDoubleEdit::GetValue
// Syntax       : BOOL GetValue(double& val, BOOL& changed)
// Access scope : public
// Input        :
//	val	- Reference to destination
//	changed	- Reference to variable to flag any change	
// Output       : Sets 'val' and 'changed', returns TRUE if is ok, FALSE otherwise.
// Description  : The edit field is scanned for a double and is assigned to
//		  val if it has changed. If it has changed, 'changed' is set to TRUE
// Remarks      :
//*****************************************************************************
//
BOOL TDoubleEdit::GetValue(double& val, BOOL& changed)
{
	char str[32];
        char *endptr;
        double newval;

	GetText(str, 32);
	newval = strtod(str, &endptr);
	if(newval != val)
	{
		val = newval;
                changed = TRUE;
        }
	return *endptr == '\0';
}


//
//*****************************************************************************
// Function    	: TStringEdit::GetValue
// Syntax       : BOOL GetValue(char *val, BOOL& changed)
// Access scope : public
// Input        :
//	val	- Reference to destination
//	changed	- Reference to variable to flag any change	
// Output       : Sets 'val' and 'changed', returns TRUE if is ok, FALSE otherwise.
// Description  : The edit field is scanned for a string and is assigned to
//		  val if it has changed. If it has changed, 'changed' is set to TRUE
// Remarks      :
//*****************************************************************************
//
BOOL TStringEdit::GetValue(char *val, BOOL& changed)
{
	char str[32];

	GetText(str, 32);

	if(strcmp(str, val))
        {
		strcpy(val, str);
                changed = TRUE;
	}

	return TRUE;
}


