/*
 ******************************************************************************
 * File                 : ekmedit.h
 * Module               : EKM	
 * Project              : EKM
 * Description          : customized edit controls	
 * Creation date        : 01-Apr-1993
 * Last update          : 01-Apr-1993
 * Author(s)            : Bertho Stultiens (BS)
 * Version              : 1.0
 * Compiler             : Borland C++ 3.1
 *      switches        :
 * Remarks              :
 * Modification History :
 * BS   01-Apr-1993:    Created this file
 ******************************************************************************
 */

#ifndef __EKMEDIT_H
#define __EKMEDIT_H

#ifndef __WINDOWS_H
#include <windows.h>
#endif

#ifndef __EDIT_H
#include <edit.h>
#endif

_CLASSDEF(TCharEdit)
class _CLASSTYPE TCharEdit : public TEdit
{
public:
	TCharEdit(PTWindowsObject aParent, int RcsId, WORD aLen) :
		TEdit(aParent, RcsId, aLen) {};

	virtual void NFENKillFocus(RTMessage) = [NF_FIRST + EN_KILLFOCUS];	
	BOOL GetValue(char& val, BOOL& changed);
};

_CLASSDEF(TUCharEdit)
class _CLASSTYPE TUCharEdit : public TEdit
{
public:
	TUCharEdit(PTWindowsObject aParent, int RcsId, WORD aLen) :
		TEdit(aParent, RcsId, aLen) {};

	virtual void NFENKillFocus(RTMessage) = [NF_FIRST + EN_KILLFOCUS];	
	BOOL GetValue(unsigned char& val, BOOL& changed);
};

_CLASSDEF(TIntEdit)
class _CLASSTYPE TIntEdit : public TEdit
{
public:
	TIntEdit(PTWindowsObject aParent, int RcsId, WORD aLen) :
		TEdit(aParent, RcsId, aLen) {};

	virtual void NFENKillFocus(RTMessage) = [NF_FIRST + EN_KILLFOCUS];	
	BOOL GetValue(int& val, BOOL& changed);
};

_CLASSDEF(TUIntEdit)
class _CLASSTYPE TUIntEdit : public TEdit
{
public:
	TUIntEdit(PTWindowsObject aParent, int RcsId, WORD aLen) :
		TEdit(aParent, RcsId, aLen) {};

	virtual void NFENKillFocus(RTMessage) = [NF_FIRST + EN_KILLFOCUS];	
	BOOL GetValue(unsigned int& val, BOOL& changed);
};

_CLASSDEF(TLongEdit)
class _CLASSTYPE TLongEdit : public TEdit
{
public:
	TLongEdit(PTWindowsObject aParent, int RcsId, WORD aLen) :
		TEdit(aParent, RcsId, aLen) {};

	virtual void NFENKillFocus(RTMessage) = [NF_FIRST + EN_KILLFOCUS];	
	BOOL GetValue(long& val, BOOL& changed);
};

_CLASSDEF(TULongEdit)
class _CLASSTYPE TULongEdit : public TEdit
{
public:
	TULongEdit(PTWindowsObject aParent, int RcsId, WORD aLen) :
		TEdit(aParent, RcsId, aLen) {};

	virtual void NFENKillFocus(RTMessage) = [NF_FIRST + EN_KILLFOCUS];	
	BOOL GetValue(unsigned long& val, BOOL& changed);
};

_CLASSDEF(TStringEdit)
class _CLASSTYPE TStringEdit : public TEdit
{
public:
	TStringEdit(PTWindowsObject aParent, int RcsId, WORD aLen) :
		TEdit(aParent, RcsId, aLen) {};

	virtual void NFENKillFocus(RTMessage) = [NF_FIRST + EN_KILLFOCUS];	
	BOOL GetValue(char *val, BOOL& changed);
};

_CLASSDEF(TDoubleEdit)
class _CLASSTYPE TDoubleEdit : public TEdit
{
public:
	TDoubleEdit(PTWindowsObject aParent, int RcsId, WORD aLen) :
		TEdit(aParent, RcsId, aLen) {};

	virtual void NFENKillFocus(RTMessage) = [NF_FIRST + EN_KILLFOCUS];	
	BOOL GetValue(double& val, BOOL& changed);
};


#endif
