/*
 ******************************************************************************
 * File                 : ini.h
 * Module               : 
 * Project              : View dumpfile
 * Description          : Ini file management
 * Creation date        : 31-Mrt-1993
 * Last update          : 23-Apr-1995
 * Author(s)            : Bertho Stultiens (BS)
 * Version              : 1.0
 * Compiler             : Borland C++ 3.1
 *      switches        :
 * Remarks              :
 * Modification History :
 * BS   31-Mrt-1993:    Created this file
 * BS	23-Apr-1995:	Copied from EKM project and changed INIFILENAME and the
 *			parameter enumeration to work with this project.
 *			Added the windows.h include. 
 ******************************************************************************
 */

#ifndef __INI_H
#define __INI_H

#ifndef __WINDOWS_H
#include <windows.h>
#endif

#define INIFILENAME	"viewdmp.ini"

enum EIniParameter		// Parameters in the ini file
{
	eip_PaletteDir = 0,
	eip_LastPaletteLoaded,		// Last loaded palette to view

        eip_LastParameter		// Must be last in line
};

enum EOnOff			// Special type for character output of booleans
{
	eb_Off = 0,
	eb_On = 1
};

BOOL SetIniParameter(EIniParameter parm, char& value);
BOOL SetIniParameter(EIniParameter parm, unsigned char& value);
BOOL SetIniParameter(EIniParameter parm, int& value);
BOOL SetIniParameter(EIniParameter parm, unsigned int& value);
BOOL SetIniParameter(EIniParameter parm, long& value);
BOOL SetIniParameter(EIniParameter parm, unsigned long& value);
BOOL SetIniParameter(EIniParameter parm, float& value);
BOOL SetIniParameter(EIniParameter parm, double& value);
BOOL SetIniParameter(EIniParameter parm, char *value);
BOOL SetIniParameter(EIniParameter parm, EOnOff& value);

BOOL GetIniParameter(EIniParameter parm, char& value);
BOOL GetIniParameter(EIniParameter parm, unsigned char& value);
BOOL GetIniParameter(EIniParameter parm, int& value);
BOOL GetIniParameter(EIniParameter parm, unsigned int& value);
BOOL GetIniParameter(EIniParameter parm, long& value);
BOOL GetIniParameter(EIniParameter parm, unsigned long& value);
BOOL GetIniParameter(EIniParameter parm, float& value);
BOOL GetIniParameter(EIniParameter parm, double& value);
BOOL GetIniParameter(EIniParameter parm, char *value, int maxlen);
BOOL GetIniParameter(EIniParameter parm, EOnOff& value);

#endif
