//
//************************************************************************
// File                 : viewwin.cpp  
// Module               : 	
// Project              : View dumpfile  
// Description          :
// Creation date        : 13-Apr-1995 
// Last update          : 
// Author(s)            : Bertho Stultiens (BS)
// Version              :
// Compiler             : Borland C++ 3.1
//	switches	:
// Remarks              :
// Modification History :
//************************************************************************
// 

#include <owl.h>
#include <dialog.h>
#include <filedial.h>
#include <bwcc.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <dir.h>
#include "viewwin.h"
#include "dumpwin.h"

//
//*****************************************************************************
// Function	: TViewDumpWindow::TViewDumpWindow
// Syntax	: TViewDumpWindow(LPSTR ATitle, LPSTR MenuName, PTModule AModule)
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
TViewDumpWindow::TViewDumpWindow(LPSTR ATitle, LPSTR MenuName, PTModule AModule)
		 : TMDIFrame(ATitle, MenuName, AModule)
{
	HDC screenDC = GetDC(NULL);
	int xsize = GetDeviceCaps(screenDC, HORZRES);
	int ysize = GetDeviceCaps(screenDC, VERTRES);
	Attr.W = xsize * 9 / 10;
	Attr.H = ysize * 9 / 10;
	Attr.X = abs((xsize - Attr.W)/2);
	Attr.Y = abs((ysize - Attr.H)/2);
	ReleaseDC(NULL, screenDC);

	ChildMenuPos = 2;	// Add to Window menu
}


//
//*****************************************************************************
// Function	: TViewDumpWindow::~TViewDumpWindow
// Syntax	: ~TViewDumpWindow()
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
TViewDumpWindow::~TViewDumpWindow()
{
}


//
//*****************************************************************************
// Function	: TViewDumpWindow::SetupWindow
// Syntax	: void SetupWindow(void)
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TViewDumpWindow::SetupWindow(void)
{
	TMDIFrame::SetupWindow();
}


//
//*****************************************************************************
// Function	: TViewDumpWindow::Error
// Syntax	: void Error(char *fmt, ...)
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TViewDumpWindow::Error(char *fmt, ...)
{
	char str[256];
	va_list va;

	va_start(va, fmt);
	vsprintf(str, fmt, va);
	BWCCMessageBox(HWindow, str, "Error...", MB_OK | MB_ICONHAND);
	va_end(va);
}


//
//*****************************************************************************
// Function	: TViewDumpWindow::Question
// Syntax	: int Question(char *fmt, ...)
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
int TViewDumpWindow::Question(char *fmt, ...)
{
	char str[256];
	va_list va;
	int retval;

	va_start(va, fmt);
	vsprintf(str, fmt, va);
	retval = BWCCMessageBox(HWindow, str, "Question...", MB_YESNO | MB_ICONQUESTION);
	va_end(va);
        return retval;
}


//
//*****************************************************************************
// Function	: TViewDumpWindow::WMQueryNewPalette
// Syntax	: void WMQueryNewPalette(RTMessage)
// Input	:
// Output	: 
// Description	: Patch the message to the active child 
// Remarks	: Why doesn't OWL do this for me ?????
//*****************************************************************************
//
void TViewDumpWindow::WMQueryNewPalette(RTMessage aMsg)
{
	if(ActiveChild != NULL)
        {
		aMsg.Result = SendMessage(ActiveChild->HWindow, aMsg.Message, aMsg.WParam, aMsg.LParam);
	}
	else
	{
		aMsg.Result = FALSE;
        }
}


//
//*****************************************************************************
// Function	: TViewDumpWindow::CMFileOpen
// Syntax	: void CMFileOpen(RTMessage aMsg)
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TViewDumpWindow::CMFileOpen(RTMessage)
{
	static char path[MAXPATH] = "\\ekm\\dmpfiles\\*.dmp";
	static char drive[MAXDRIVE];
	static char dir[MAXDIR];
	static char name[MAXFILE];
	static char ext[MAXEXT]; 
	DWORD memfree;

	if(fnsplit(path, drive, dir, name, ext) & WILDCARDS)
	{
		fnmerge(path, drive, dir, name, ext);
	}
	else
	{
		fnmerge(path, drive, dir, "*", ".dmp");
	}

	if((memfree = GetFreeSpace(0l)) < 4500000l)
	{
		if(Question("You are running out of memory (%lu Bytes free, need at least 3,750,000 Bytes).\nTry to open another dumpfile?", memfree) != IDYES)
		{
                	return;
                }
	}

	if(GetApplication()->ExecDialog(new TFileDialog(this, SD_FILEOPEN, path)) == IDOK)
	{
		HFILE hf;

		if((hf = _lopen(path, READ)) == HFILE_ERROR)
		{
                	MessageBeep(-1);
			Error("File <%s> not found", path);
                        return;
		}
		_lclose(hf);

                GetApplication()->MakeWindow(new TDumpWindow(this, path, path));
        }
}


//
//*****************************************************************************
// Function	: TViewDumpWindow::CMWindowAbout
// Syntax	: void CMWindowAbout(RTMessage aMsg)
// Input	:
// Output	: 
// Description	: 
// Remarks	:
//*****************************************************************************
//
void TViewDumpWindow::CMWindowAbout(RTMessage)
{
	GetApplication()->ExecDialog(new TDialog(this, "DIALOG_ABOUT"));
}
   
