#ifndef __VIEWWIN_H
#define __VIEWWIN_H


#ifndef __MDI_H
#include <mdi.h>
#endif

#ifndef __VIEWDMPR_H
#include "viewdmpr.h"
#endif

_CLASSDEF(TViewDumpWindow)

class TViewDumpWindow : public TMDIFrame
{
public:

public:
	TViewDumpWindow(LPSTR ATitle, LPSTR MenuName, PTModule AModule = NULL);
	~TViewDumpWindow();

	LPSTR GetClassName()
	{
		return "TViewDumpWindow";
	}

	/* The program has its own icon which is installed here. */
	void GetWindowClass(WNDCLASS& AWndClass)
	{
		TMDIFrame::GetWindowClass(AWndClass);
		AWndClass.hIcon = LoadIcon(GetApplication()->hInstance, "ICON_VIEWDUMP");
	}

	virtual void SetupWindow(void);

	virtual void CMFileOpen(RTMessage aMsg)		= [CM_FIRST + CM_FILEOPEN];
	virtual void CMWindowAbout(RTMessage aMsg)	= [CM_FIRST + CM_WINDOWABOUT];
	virtual void WMQueryNewPalette(RTMessage Msg)	= [WM_FIRST + WM_QUERYNEWPALETTE];

	void Error(char *fmt, ...);
	int Question(char *fmt, ...);
};

#endif
